
Ruby - Bug #8770

[PATCH] process.c: avoid EINTR from Process.spawn

08/11/2013 06:11 AM - normalperson (Eric Wong)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version:    

ruby -v: 44687,44706,44727 Backport:  

Description

(send_child_error): retry write on EINTR

(recv_child_error): retry read on EINTR

I've been getting occasional Errno::EINTR from Process.spawn with

just the prog name in the error message.  This is probably the cause

of it, as I haven't been able to get a consistent reproduction of

the Errno::EINTR.

I've been hitting this on 2.0.0-p247, so it probably needs backport.

Associated revisions

Revision fbf4850cabbb7dc50be08660fe39889d03a03b96 - 01/28/2014 11:54 AM - akr (Akira Tanaka)

process.c (READ_FROM_CHILD): Apply the last hunk of

0001-process.c-avoid-EINTR-from-Process.spawn.patch written by

Eric Wong in [Bug #8770].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@44727 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision fbf4850c - 01/28/2014 11:54 AM - akr (Akira Tanaka)

process.c (READ_FROM_CHILD): Apply the last hunk of

0001-process.c-avoid-EINTR-from-Process.spawn.patch written by

Eric Wong in [Bug #8770].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@44727 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6770402812366dac38469876c7493c9e3ab71ffe - 02/20/2014 04:44 AM - naruse (Yui NARUSE)

merge revision(s) 44687,44706,44727: [Backport #8770]

    * process.c (recv_child_error): Fix deadlock in rb_fork_internal when a

 signal is sent to the parent process while Ruby is forking in IO.popen.

Patch by Scott Francis. Closes GH-513.

* process.c (send_child_error): retry write on EINTR to fix

occasional Errno::EINTR from Process.spawn.

    * process.c (recv_child_error): retry read on EINTR to fix

      occasional Errno::EINTR from Process.spawn.

    * process.c (READ_FROM_CHILD): Apply the last hunk of

      0001-process.c-avoid-EINTR-from-Process.spawn.patch written by

      Eric Wong in [Bug #8770].

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@45061 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 67704028 - 02/20/2014 04:44 AM - naruse (Yui NARUSE)

merge revision(s) 44687,44706,44727: [Backport #8770]

    * process.c (recv_child_error): Fix deadlock in rb_fork_internal when a

 signal is sent to the parent process while Ruby is forking in IO.popen.
Patch by Scott Francis. Closes GH-513.

* process.c (send_child_error): retry write on EINTR to fix

occasional Errno::EINTR from Process.spawn.

    * process.c (recv_child_error): retry read on EINTR to fix

      occasional Errno::EINTR from Process.spawn.

    * process.c (READ_FROM_CHILD): Apply the last hunk of

      0001-process.c-avoid-EINTR-from-Process.spawn.patch written by

      Eric Wong in [Bug #8770].

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@45061 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 08/11/2013 09:11 AM - nobu (Nobuyoshi Nakada)

patch please

#2 - 08/11/2013 11:39 AM - normalperson (Eric Wong)

- File 0001-process.c-avoid-EINTR-from-Process.spawn.patch added

Oops, attached

#3 - 09/17/2013 06:10 PM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to nobu (Nobuyoshi Nakada)

#4 - 01/24/2014 11:24 PM - normalperson (Eric Wong)

It looks like r44687 implements a partial fix for this, but my

proposed patch covers more cases and is more complete.

* process.c (recv_child_error): Fix deadlock in rb_fork_internal when a

  signal is sent to the parent process while Ruby is forking in IO.popen.

 Patch by Scott Francis. Closes GH-513.

#5 - 01/25/2014 05:56 AM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

- Backport changed from 1.9.3: UNKNOWN, 2.0.0: UNKNOWN to 1.9.3: REQUIRED, 2.0.0: REQUIRED, 2.1: REQUIRED

Oops, I missed to include the reference in r44706.

#6 - 01/25/2014 08:11 AM - normalperson (Eric Wong)

nobu@ruby-lang.org wrote:

Oops, I missed to include the reference in r44706.

 No worries.  Interesting, now I notice test_process now fails under

heavy load with this patch...

This should fix things: http://bogomips.org/ruby.git/patch?id=81b6f37afe34

git://80x24.org/ruby.git test_process-avoid-teardown

#7 - 01/26/2014 01:01 AM - nobu (Nobuyoshi Nakada)

Is it an issue of the test code?

http://c5664.rubyci.org/~chkbuild/ruby-trunk/log/20140125T233302Z.log.html.gz

#8 - 01/26/2014 01:29 AM - normalperson (Eric Wong)

nobu@ruby-lang.org wrote:

Is it an issue of the test code?

http://c5664.rubyci.org/~chkbuild/ruby-trunk/log/20140125T233302Z.log.html.gz
 Odd, I did not get this:

1. Error:

TestProcess#test_deadlock_by_signal_at_forking:

Errno::EINTR: Interrupted system call - /home/chkbuild/build/20140125T233302Z/ruby/ruby

/home/chkbuild/build/20140125T233302Z/ruby/test/ruby/test_process.rb:1875:in popen'     

/home/chkbuild/build/20140125T233302Z/ruby/test/ruby/test_process.rb:1875:in block in test_deadlock_by_signal_at_forking'

/home/chkbuild/build/20140125T233302Z/ruby/test/ruby/test_process.rb:1873:in times'     

/home/chkbuild/build/20140125T233302Z/ruby/test/ruby/test_process.rb:1873:in test_deadlock_by_signal_at_forking'

Instead, I got this (with TESTS=-j32):

/home/ew/ruby/test/ruby/test_process.rb:15:in waitall': SIGTERM (SignalException) /home/ew/ruby/test/ruby/test_process.rb:15:in teardown'

/home/ew/ruby/lib/minitest/unit.rb:1280:in `block in run'

I don't think I was able to reproduce it on a single-threaded test-all.

#9 - 01/28/2014 11:59 AM - akr (Akira Tanaka)

I think the Errno::EINTR error occur inTestProcess#test_deadlock_by_signal_at_forking because

r44706 doesn't contain the last hunk in 0001-process.c-avoid-EINTR-from-Process.spawn.patch.

I committed the hunk at r44727.

#10 - 01/28/2014 07:14 PM - normalperson (Eric Wong)

akr@fsij.org wrote:

I think the Errno::EINTR error occur inTestProcess#test_deadlock_by_signal_at_forking because

r44706 doesn't contain the last hunk in 0001-process.c-avoid-EINTR-from-Process.spawn.patch.

I committed the hunk at r44727.

 Good catch, things look good, thanks!

#11 - 02/19/2014 04:55 AM - tmm1 (Aman Karmani)

- Tracker changed from Bug to Backport

- Target version deleted (2.1.0)

- Project changed from Ruby to 17

- Category deleted (core)

- Status changed from Closed to Assigned

#12 - 02/20/2014 03:52 AM - naruse (Yui NARUSE)

- Tracker changed from Backport to Bug

- Project changed from 17 to Ruby

- ruby -v set to -

- Backport set to 1.9.3: UNKNOWN, 2.0.0: UNKNOWN, 2.1: UNKNOWN

I wrote https://bugs.ruby-lang.org/projects/ruby/wiki/HowToRequestBackport

#13 - 02/20/2014 04:01 AM - naruse (Yui NARUSE)

- ruby -v changed from - to 44687,44706,44727

- Backport changed from 1.9.3: UNKNOWN, 2.0.0: UNKNOWN, 2.1: UNKNOWN to 1.9.3: REQUIRED, 2.0.0: REQUIRED, 2.1: REQUIRED

COMMITS: 44687,44706,44727

#14 - 02/20/2014 04:45 AM - naruse (Yui NARUSE)

- Backport changed from 1.9.3: REQUIRED, 2.0.0: REQUIRED, 2.1: REQUIRED to 1.9.3: REQUIRED, 2.0.0: REQUIRED, 2.1: DONE

r45061 on ruby_2_1

#15 - 08/10/2019 02:50 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Assigned to Closed

- Backport deleted (1.9.3: REQUIRED, 2.0.0: REQUIRED, 2.1: DONE)

Files

0001-process.c-avoid-EINTR-from-Process.spawn.patch 3.18 KB 08/11/2013 normalperson (Eric Wong)
